import * as t from '@babel/types';
import node_path from 'path';
export default function babelPluginAntdStyle() {
  if (process.env.NODE_ENV === 'production') {
    return {};
  }
  var aliasCreateStyles = 'createStyles';
  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path) {
        if (path.type !== 'ImportDeclaration') {
          return;
        }
        var value = path.node.source.value;
        if (value === 'antd-style' && path.node.specifiers.find(function (item) {
          var _item$imported;
          return ((_item$imported = item.imported) === null || _item$imported === void 0 ? void 0 : _item$imported.name) === 'createStyles';
        })) {
          var specifiers = path.node.specifiers.find(function (item) {
            var _item$imported2;
            return ((_item$imported2 = item.imported) === null || _item$imported2 === void 0 ? void 0 : _item$imported2.name) === 'createStyles';
          });
          if (!specifiers.local) {
            return;
          }
          aliasCreateStyles = specifiers.local.name;
        }
      },
      CallExpression: function CallExpression(path, state) {
        if (state.file.opts.filename.includes('node_modules')) {
          return;
        }
        var fileName = node_path.relative(state.file.opts.root, state.file.opts.filename);
        if (!['createStyles', aliasCreateStyles].includes(path.node.callee.name)) return;
        var __BABEL_FILE_NAME__ = t.objectExpression([t.objectProperty(t.identifier('__BABEL_FILE_NAME__'), t.stringLiteral(fileName.split(node_path.sep).map(function (path) {
          return path.split('.').at(0);
        }).filter(function (path) {
          return path && path !== 'src' && path !== 'index' && path !== '.' && path !== '..';
        }).join('-')))]);
        if (path.node.arguments.length === 1) {
          path.node.arguments.push(__BABEL_FILE_NAME__);
          return;
        }
        if (path.node.arguments.length === 2 && path.node.arguments[1].type === 'ObjectExpression') {
          var properties = path.node.arguments[1].properties;
          if (properties.find(function (item) {
            return item.key.name !== '__BABEL_FILE_NAME__';
          })) {
            return;
          } else {
            properties.push(__BABEL_FILE_NAME__);
          }
          return;
        }
      }
    }
  };
}